package com.ruoyi.mall.service;

import java.util.List;
import com.ruoyi.mall.domain.MallGoodsProduct;
import com.ruoyi.mall.domain.vo.GoodsProductVO;
import org.apache.ibatis.annotations.Param;

/**
 * 商品 产品Service接口
 *
 * @author chang
 * @date 2021-11-25
 */
public interface IMallGoodsProductService
{
    /**
     * 查询商品 产品
     *
     * @param id 商品 产品主键
     * @return 商品 产品
     */
    public MallGoodsProduct selectMallGoodsProductById(Long id);

    /**
     * 查询商品 产品列表
     *
     * @param mallGoodsProduct 商品 产品
     * @return 商品 产品集合
     */
    public List<MallGoodsProduct> selectMallGoodsProductList(MallGoodsProduct mallGoodsProduct);

    /**
     * 新增商品 产品
     *
     * @param mallGoodsProduct 商品 产品
     * @return 结果
     */
    public int insertMallGoodsProduct(MallGoodsProduct mallGoodsProduct);

    /**
     * 修改商品 产品
     *
     * @param mallGoodsProduct 商品 产品
     * @return 结果
     */
    public int updateMallGoodsProduct(MallGoodsProduct mallGoodsProduct);

    /**
     * 批量删除商品 产品
     *
     * @param ids 需要删除的商品 产品主键集合
     * @return 结果
     */
    public int deleteMallGoodsProductByIds(Long[] ids);

    /**
     * 删除商品 产品信息
     *
     * @param id 商品 产品主键
     * @return 结果
     */
    public int deleteMallGoodsProductById(Long id);

    /*
     * 根据商品id、规格id 查价格、库存等
     * */
    public List<GoodsProductVO> selectMallGoodProByParams(MallGoodsProduct pro);

    //加库存
    public void updateMallGoodsProductByParamsRefund(Long productId, Integer total);

    //减库存
    public void updateMallGoodsProductByParams(Long productId, Integer total);

    /**
     * 设置一个默认规格
     *
     * @param goodsId 商品ID
     * @return 商品 产品集合
     */
    public int setDefault(Long goodsId);
}
